import edu.smcvt.graphics.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class FireworksDemo extends JFrame implements ActionListener{

	JButton runButton, pauseButton, killButton;
	JLabel statusLabel;
	JAnimationPanel drawer;
	Thread dThread;
	

	public FireworksDemo(int dW, int dH, int ms){
	
		Container cp = getContentPane();
		BorderLayout blm = new BorderLayout();
		cp.setLayout(blm);
		dThread = null;
		
		runButton = new JButton("Run");
		pauseButton = new JButton("Pause");
		killButton = new JButton("Stop");
		
		statusLabel = new JLabel("Ready...");
		
		drawer = new JAnimationPanel(ms,new FireworksWorld());
		drawer.setSize(dW,dH);
		drawer.setPreferredSize(new Dimension(dW,dH));
		
		cp.add(runButton, BorderLayout.WEST);
		cp.add(pauseButton, BorderLayout.CENTER);
		cp.add(killButton, BorderLayout.EAST);
		cp.add(statusLabel, BorderLayout.SOUTH);
		cp.add(drawer, BorderLayout.NORTH);
		
		runButton.setEnabled(true);
		pauseButton.setEnabled(false);
		killButton.setEnabled(false);
		
		runButton.addActionListener(this);
		pauseButton.addActionListener(this);
		killButton.addActionListener(this);
		pack();
	}



	public void actionPerformed(ActionEvent e){
		Object src = e.getSource();
		statusLabel.setText("Responding to action...");
		if(src == runButton){
		
			if(drawer.isAlive())	drawer.unpause();
			else{
				dThread = new Thread(drawer);
				dThread.start();
			}
			runButton.setEnabled(false);
			pauseButton.setEnabled(true);
			killButton.setEnabled(true);
			statusLabel.setText("Running...");
		} else if(src == pauseButton){
			drawer.pause();
			runButton.setEnabled(true);
			pauseButton.setEnabled(false);
			killButton.setEnabled(true);
			statusLabel.setText("Paused...");
		} else if(src == killButton){
			drawer.die();
			dThread = null;
			runButton.setEnabled(true);
			pauseButton.setEnabled(false);
			killButton.setEnabled(false);
			statusLabel.setText("Ready...");
		} else{
			statusLabel.setText("Confused...a mystery button was clicked.");
		}
	}
	
	public static void main(String[] args){
		int tickMS = 15; // 20 is almost stately, 10 is super fast.
		FireworksDemo myFireworksDemo = new FireworksDemo(640,480,tickMS);
		myFireworksDemo.setTitle("Fireworks Demo - Thomas Dickerson");
		myFireworksDemo.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		myFireworksDemo.setVisible(true);
		
	}


}
