import java.awt.*;
import edu.smcvt.graphics.*;


public class SimpleFirework extends AnimObject{
	
	int counter;
	FireworksWorld world;
	int launchTicks, lifeTicks, numSpokes;
	Color color;
	double x,y,vx,vy;
	double size, launchAngle;
	double innerSize;
	public SimpleFirework(FireworksWorld w, int lnT, int lfT, int nS, double sz, double isz, double lV, double lX, double lA){
		world = w;
		lifeTicks = lfT;
		numSpokes = nS;
		size = sz;
		innerSize = isz;
		launchAngle = lA;
		launchTicks = lnT;
		counter = 0;
		x=lX;
		y=world.SKY_PROPORTION;
		vx=lV*Math.sin(launchAngle);
		vy=lV*Math.cos(launchAngle); // swap sin/cos for declination
	}
	
	public SimpleFirework(FireworksWorld w, int lnT, int lfT, int nS, double sz, double isz, double lV, double lX, double lA, Color c)
	{
		this(w,lnT,lfT,nS,sz,isz,lV,lX,lA);
		setColor(c);
	}
	
	public void setColor(Color c){ color = c; }
	public Color getColor(){ return color; }
	
	public void paintSelf(Graphics g, Dimension d){
		int cx, cy, xpT,ox,oy;
		double cr;
		cx = (int)(d.width * x);
		cy = (int)(d.height * y);
		xpT = counter - launchTicks;
		cr = size * xpT;
		if(counter < launchTicks){
			g.setColor(Color.WHITE);
			g.fillOval(cx, cy, 2, 2);
		} else if(counter < launchTicks + lifeTicks){
			g.setColor(color);
			for(int i = 0; i < numSpokes; i++){
				ox = (int)(cr*xpT*Math.cos(2*i*Math.PI/numSpokes));
				oy = (int)(xpT*(cr*Math.sin(2*i*Math.PI/numSpokes)+world.G*xpT));
				g.drawLine(cx+(int)(innerSize*ox),cy+(int)(innerSize*oy),cx+ox,cy+oy);
			}
		};
	}
	
	public void tick(){
		counter = Math.min(counter + 1, lifeTicks + launchTicks);
		x+=vx;
		y-=vy;
		vx+=world.WIND_SPEED;
		vy+=world.G;
		
	}
	
	public boolean isExpired(){ return counter == (lifeTicks + launchTicks); }


}
