package edu.smcvt.graphics;

import java.awt.*;
import java.util.*;
import java.util.concurrent.*;
import java.awt.event.*;
import javax.swing.*;


public class JAnimationPanel extends JPanel implements Runnable{
	private int frameMS;
	private AnimationWorld world;
	private volatile boolean running;
	private volatile boolean alive;
	public JAnimationPanel(int fMS, AnimationWorld aw){
		world = (aw == null) ? new AnimationWorld() : aw;
		frameMS = fMS;
		running = false;
		alive = false;
		
	}

	public void pause(){	running = false;	}
	public void unpause(){ running = true; }
	public void die(){ running = false; alive = false; world.resetWorld(); }
	public boolean isAlive(){ return alive; }
	public boolean isRunning(){ return running; }
	public void run(){
		running = true; alive = true;
		Graphics panelGraphics;
		while(alive){
			if(running){
				world.tick();
				panelGraphics = getGraphics();
				if(panelGraphics != null){ paint(panelGraphics); }
			
			} try {
				Thread.sleep(frameMS);
			} catch(InterruptedException ie){}
		}
	}
	
	public void paintComponent(Graphics panelGraphics){
		world.paintWorld(panelGraphics, getSize());
	}

}